; C6x EXT_INT4..7/NMI vector table
; ---------------------------------
; This vector table is universal for all XINT tests for TP6x.
; Actual function implementation is provided in C-code.
;
; This file is common for C64xx and C620x/C670x DSP and must be
; compiled with different command line options (-mv6201 and -mv6400)
; in order to meet different DSP platforms.


	.global _c_int00, _xint4_isr, _xint5_isr, _xint6_isr, _xint7_isr, _nmi_isr

	.sect "vectors"

reset:
	mvkl  .s2 _c_int00,b0
	mvkh  .s2 _c_int00,b0
	b     .s2 b0
	nop 
	nop
	nop
	nop
	nop

nmi:
	mvkl  .s2 _nmi_isr,b1
	mvkh  .s2 _nmi_isr,b1
	b     .s2 b1
	nop
	nop
	nop
	nop
	nop

rsrv2:
	b rsrv2
	nop
	nop
	nop
	nop
	nop
	nop
	nop

rsrv3:
	b rsrv3
	nop
	nop
	nop
	nop
	nop
	nop
	nop

int4:
	mvkl  .s2 _xint4_isr,b0
	mvkh  .s2 _xint4_isr,b0
	b     .s2 b0
	nop
	nop
	nop
	nop
	nop

int5:
	mvkl  .s2 _xint5_isr,b0
	mvkh  .s2 _xint5_isr,b0
	b     .s2 b0
	nop
	nop
	nop
	nop
	nop

int6:
	mvkl  .s2 _xint6_isr,b0
	mvkh  .s2 _xint6_isr,b0
	b     .s2 b0
	nop
	nop
	nop
	nop
	nop

int7:
	mvkl  .s2 _xint7_isr,b0
	mvkh  .s2 _xint7_isr,b0
	b     .s2 b0
	nop
	nop
	nop
	nop
	nop

int8:
	b int8
	nop
	nop
	nop
	nop
	nop
	nop
	nop

int9:
	b int9
	nop
	nop
	nop
	nop
	nop
	nop
	nop

int10:
	b int10
	nop
	nop
	nop
	nop
	nop
	nop
	nop

int11:
	b int11
	nop
	nop
	nop
	nop
	nop
	nop
	nop

int12:
	b int12
	nop
	nop
	nop
	nop
	nop
	nop
	nop

int13:
	b int13
	nop
	nop
	nop
	nop
	nop
	nop
	nop

int14:
	b int14
	nop
	nop
	nop
	nop
	nop
	nop
	nop

int15:
	b int15
	nop
	nop
	nop
	nop
	nop
	nop
	nop


